//Mandelbulb mit Raytracing und Multithreading
//Drehung um x-Achse: Taste 'x'   Drehung um y-Achse: Taste 'y'  Drehung um z-Achse: Taste 'z'
//Punkte auf dem Ray starten an der Projektionsfläche ABCD

int aufloesung = 1200;
int maxIt = 8; 
int exp = 8;//Wahl Exponent
int aT =12;//Anzahl Threads
int abstandScreen;
int abstandAuge;
float anteilErledigt11 ;//misst den Fortschritt in Thread 11
float laenge;
float farbFaktor;
int kStart = 255; //Anpassen der Helligkeit
int wahlVariante = 1;//Varianten des Mandelbulbs für >1
float b=1.0/255.0/255.0;
//Screen:
float[][] Auge = new float[12][3];
float[][] A = new float[12][3];
float[][] B = new float[12][3];
float[][] C = new float[12][3];
float[][] D = new float[12][3];
ArrayList<float[]>[] startPunkte = new ArrayList[aT];//Einheit: Anzahl Gitterpunkte
ArrayList<float[]>[] bildPunkte = new ArrayList[aT];//Einheit: Anzahl Gitterpunkte
ArrayList<float[]>[] raumBildPunkte = new ArrayList[aT];//Kartesische Koordinaten
ArrayList<float[]>[] raumRichtungEVs= new ArrayList[aT];//Kartesische Koordinaten
float[][]raumRichtungEV = new float[12][aT];//Elemente von raumRichtungsEVs
float[][]raumBildPunkt = new float[12][aT];;//Elemente von raumBildpunkte
float[]diEst = new float[12]; //distance estimation for every Thread
float wh;;//Abstand untere-obere Grenze
float alY ;//Drehwinkel y-Achse
float alX ;//Drehwinkel x-Achse
float alZ ;//Drehwinkel z-Achse
float fak ;//Umrechnungsfaktor von Gitterpunkte in kart.Koordinaten
float[] abstand = new float[12];//...vom Ursprung
float fVariante;//Farbgebung durch Zufall;
PImage bild;
boolean farbigZeichnen = true;
boolean nextStep = true;
boolean zoom = false;
boolean leuchtkraft;
boolean normal;
boolean kontrast;
ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
float[]tempD = new float[12];//verwendet für hell-dunkel
float[]tempF = new float[12];//verwendet für Farbe
float[] grauWerte = new float[aufloesung*aufloesung];
float[] farbWerte = new float[aufloesung*aufloesung];
//-------------------------------------------------
void setup(){
  size(1200,1200,P2D);
  colorMode(HSB);
  wh = 1.2;//max Ausdehnung in allen Achsen (Würfel Kantenlänge 2.2, Mittelpunkt Ursprung (Zoom: wh=0.7)
  fak = wh/aufloesung;//enstspricht Entfernung zwischen den einzelnen Gitterpunkten
  farbFaktor = 0.8;
  alX = 0; alY = 0; 
  normal = true;
  leuchtkraft = false;
  kontrast = false;
  abstandScreen = 2000;
  abstandAuge = 4000;
  fVariante = random(50,255);
  initialisieren();
  starten();
}
//-----------------------------------------------------------
void draw(){
  if(nextStep){  
    loadPixels();
    PImage bild = createImage(width,height,RGB);
    
     if(farbigZeichnen){
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
          bild.pixels[i] =  color(farbWerte[i],240,grauWerte[i]);            
       }
     }else{
       for (int i = 0; i < aufloesung*aufloesung; i++) {  
         bild.pixels[i] =  color(grauWerte[i]);            
       }
     }    
     println("Kantenlänge des zu untersuchenden Bereichs (Würfel mit O als Zentrum): "+wh); 
     println("Abstand Gitterpunkte enspricht der Länge: "+fak," Abstand Screen: "+abstandScreen);
     println("Time: "+millis());//bei distEst 0.3*  : 405, bei 0.5* : 84 => mehr Kontrast bei 0.3
     println("Winkel Drehung y-Achse: "+alY+ " x-Achse: "+ alX + " z-Achse: "+ alZ);
     println("Exponent: "+exp," Farbfaktor: "+farbFaktor," Leuchtkraft: "+leuchtkraft);
  
     image(bild,0,0);
     save("bild.jpg");  
     nextStep=false;
     System.gc();
    }
}
//----------------------------------------------------------------------
void starten(){   
  //Platz für Erweiterungen
  multiThreadsStarten();  
}
//--------------------------------------------------------------------------
void multiThreadsStarten(){
   workers.clear();
   for (int i=0; i<12; i++)
    {
      workers.add(new WorkThread(i)); 
    }
    for (WorkThread worker : workers) {  
      while (worker.running)
      {       
        try{
        Thread.sleep(10);  
        }catch (Exception e) {  }  ;                
      }
    }
    for(int n =0; n<12; n++){
      tempD = workers.get(n).pixValuesGray[n];  
      tempF = workers.get(n).pixValuesColor[n];
      for(int i = 0; i<aufloesung*100;i++){
            grauWerte[i+n*aufloesung*100]=tempD[i];
            farbWerte[i+n*aufloesung*100]=tempF[i];
      }
    }
}
//------------------------------------------------------------
float[] matrixMalvector(float[][] M, float[] V){
    float[] ergebnisV = new float[3];
      for(int i=0;i<3;i++){ 
        ergebnisV[i] = M[i][0]*V[0]+M[i][1]*V[1]+M[i][2]*V[2];      
      }
    return ergebnisV;
}
//---------------------------------------------------------------------
float[] drehenX(int n, float alpha, float[] Vector){
    alX = alpha;
    float[][]   Dx =  {{ 1     ,      0      ,     0     },
                      {  0     ,    cos(alX) ,  -sin(alX)},
                      {  0     ,    sin(alX) ,   cos(alX)}};
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dx,Vector);
    return gedrehterV;    
}
//---------------------------------------------------------------------
float[] drehenY(int n, float alpha, float[] Vector){
    alY = alpha;
    float[][] Dy =  { {cos(alY) ,   0   ,sin(alY)},
                      {  0     ,   1   ,   0   },
                      {-sin(alY),   0   , cos(alY)}   };
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dy,Vector);
    return gedrehterV;    
}
//---------------------------------------------------------------------
float[] drehenZ(int n, float alpha, float[] Vector){
    alZ = alpha;
      float[][] Dz =  {{  cos(alZ) ,   -sin(alZ),    0    },
                      {   sin(alZ)  ,   cos(alZ),    0    },
                      {      0     ,          0 ,    1    }};
    float[] gedrehterV = new float[3];
    gedrehterV =matrixMalvector(Dz,Vector);
    return gedrehterV;    
}
//-----------------------------------------------------------------------------------
void gedrehtePunkteBerechnen(int n,float winkelY, float winkelX){
  bildPunkte[n] = new ArrayList<float[]>();raumBildPunkte[n] = new ArrayList<float[]>();
  raumRichtungEVs[n] = new ArrayList<float[]>();
  alY = winkelY;alX = winkelX;
  Auge[n] = drehenY(n,alY,Auge[n]);Auge[n] = drehenX(n,alX,Auge[n]);Auge[n] = drehenZ(n,alZ,Auge[n]);

  for(int j=0;j<aufloesung*aufloesung/aT; j++){ 
    float[] bP =drehenY(n,alY,startPunkte[n].get(j));bP = drehenX(n,alX,bP); bP = drehenZ(n,alZ,bP); 
    float[] raumBP = {bP[0]*fak,bP[1]*fak,bP[2]*fak};
    float[] richtung = {bP[0]-Auge[n][0],bP[1]-Auge[n][1],bP[2]-Auge[n][2]};
    laenge = sqrt(sq(bP[0]-Auge[n][0])+sq(bP[1]-Auge[n][1])+sq(bP[2]-Auge[n][2]));
    float[] raumEV = {(float)richtung[0]/laenge,(float)richtung[1]/laenge,(float)richtung[2]/laenge};
    bildPunkte[n].add(bP);raumBildPunkte[n].add(raumBP);
   
    raumRichtungEVs[n].add(raumEV);
  }
}
//---------------------------------------------------------------------
void startPunkteBerechnen(int n, int abstandScreen){
  int a = aufloesung/2;
  startPunkte[n] = new ArrayList<float[]>();
  for(int i=n*aufloesung/aT; i<(n+1)*aufloesung/aT; i++){
     for(int j=0;j<aufloesung; j++){     
       float[] p = {-abstandScreen,-a+j,-a+i};    
       startPunkte[n].add(p);
     }
  } 
}
//---------------------------------------------------------------------------
void initialisieren(){
   anteilErledigt11 = 0;
   if(zoom){
    for(int n = 0; n < aT; n++){
       Auge[n][0]=-abstandAuge;Auge[n][1]=0;Auge[n][2]=0;
    }  
    for(int n = 0; n < aT; n++){
       A[n][0]=-abstandScreen;A[n][1]=-600;A[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       B[n][0]=-abstandScreen;B[n][1]=-600;B[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       C[n][0]=-abstandScreen;C[n][1]=-600;C[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       D[n][0]=-abstandScreen;D[n][1]=-600;D[n][2]=-600;
    }  
   }else{
    for(int n = 0; n < aT; n++){
       Auge[n][0]=-abstandAuge;Auge[n][1]=0;Auge[n][2]=0;
    }  
    for(int n = 0; n < aT; n++){
       A[n][0]=-abstandScreen;A[n][1]=-600;A[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       B[n][0]=-abstandScreen;B[n][1]=-600;B[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       C[n][0]=-abstandScreen;C[n][1]=-600;C[n][2]=-600;
    }  
    for(int n = 0; n < aT; n++){
       D[n][0]=-abstandScreen;D[n][1]=-600;D[n][2]=-600;
    }  
   }
  for (int i = 0; i < aT; i++) {
            startPunkte[i] = new ArrayList<float[]>();
  }
  for (int i = 0; i < aT; i++) {
            bildPunkte[i] = new ArrayList<float[]>();
  }
  for (int i = 0; i < aT; i++) {
            raumBildPunkte[i] = new ArrayList<float[]>();
  }
  for (int i = 0; i < aT; i++) {
            raumRichtungEVs[i] = new ArrayList<float[]>();
  }     
}
//-------------------------------------------------------------------------
void keyPressed(){
   if (key == 'y') {//Drehung um y-Achse
    alY = alY - PI/8;    
    initialisieren();    
    nextStep = true;
    starten();    
  }
  if (key == 'x') {//Drehung um x-Achse
    alX = alX + PI/6;   
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'z') {//Drehung um z-Achse
    alZ = alZ + PI/8;   
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'g') {//farbig/grau Zeichnen
    farbigZeichnen = !farbigZeichnen;
    initialisieren();    
    nextStep = true;
    starten();
  }
   if (key == 'h') {//heller Zeichnen
    kStart = kStart+50;
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == 'H') {//kunkler Zeichnen
    kStart = kStart-30;
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == 'w') {//Farbe wechseln
    fVariante = random(50,255);
    initialisieren();    
    nextStep = true;
    starten();
  }
  if (key == 'Z') {//Zoom  
    zoom = true;
    abstandScreen = 50000;
    abstandAuge = 100000;
    wh=wh/2; fak = wh/aufloesung;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'n') {//Zoom, Kontrast...beenden
    zoom = false;
    normal = true;
    abstandScreen = 2000;
    wh=1.2; fak = wh/aufloesung;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '+') {//Exponent erhöhen
    zoom = false;
    abstandScreen = 2000;
    wh=1.2; fak = wh/aufloesung;
    exp = exp+1;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '-') {//Exponent verringern
    zoom = false;
    abstandScreen = 2000;
    wh=1.2; fak = wh/aufloesung;
    if(exp>3)exp = exp-1;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'F') {//Farbfaktor vergrößern
    farbFaktor = farbFaktor*1.4;   
    initialisieren();    
    nextStep = true;
    starten();    
  }
  if (key == 'f') {//Farbfaktor verkleinern
    farbFaktor = farbFaktor/1.4;   
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'l') {//leuchtkraft erhöhen
    normal=false;kontrast=false;
    leuchtkraft=true;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == 'k') {//leuchtkraft erhöhen
    normal=false;leuchtkraft=false;
    kontrast=true;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '1') {//Variante 1
    wh = 1.2;
    fak = wh/aufloesung;
    wahlVariante =1;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '2') {//Variante 2
    wh = 1.2;
    alY = PI/8; alX = PI/2; alZ = PI/2;
    fak = wh/aufloesung;
    wahlVariante =2;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '3') {//Variante 3
    wh = 1.3;
    fak = wh/aufloesung;
    kStart = kStart+50;
    wahlVariante =3;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '4') {//Variante 3
    wh = 2.0;
    alY = PI/8; alX = PI/6; alZ = 0;
    fak = wh/aufloesung;
    wahlVariante =4;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '5') {//Variante 5
    wh = 1.2;
    fak = wh/aufloesung;
    wahlVariante =5;
    initialisieren();    
    nextStep = true;
    starten();   
  }
   if (key == '6') {//Variante 6
    wh = 1.2;
    alZ = 3*PI/4;
    fak = wh/aufloesung;
    wahlVariante =6;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '7') {//Variante 7
    wh = 1.2;
    fak = wh/aufloesung;
    wahlVariante =7;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '8') {//Variante 8
    wh = 1.4;
    fak = wh/aufloesung;
    kStart = kStart+100;
    wahlVariante =8;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '9') {//Variante 9
    wh = 1.4;
    fak = wh/aufloesung;
    wahlVariante =9;
    initialisieren();    
    nextStep = true;
    starten();   
  }
  if (key == '0') {//Variante 10
    wh = 1.5;
    fak = wh/aufloesung;
    kStart = kStart+100;
    wahlVariante =10;
    initialisieren();    
    nextStep = true;
    starten();   
  }
}
//////////////////////////////////////////////////////////////////////////////////
class WorkThread implements Runnable {

  protected boolean running = true;
  private int nummer;
   
  ArrayList<WorkThread> workers = new ArrayList<WorkThread>();
  
  float[][] pixValuesGray  =  new float[aT][aufloesung*100];//for every Thread
  float[][] pixValuesColor =  new float[aT][aufloesung*100];
       
  public WorkThread (int nummer){
    this.nummer = nummer;
    Thread thread = new Thread(this);
    thread.start();
  }
  public void run() {       
      this.running = true;
      println("Die interne Threadnummer ist: " 
       + Thread.currentThread().getId() + ", Eigene Threadnummer: " + nummer);
       
        switch(nummer){  
      case 0:pixelBerechnen( 0); break;              
      case 1:pixelBerechnen( 1); break;                
      case 2:pixelBerechnen( 2); break;                 
      case 3:pixelBerechnen( 3); break;            
      case 4:pixelBerechnen( 4); break;            
      case 5:pixelBerechnen( 5); break;          
      case 6:pixelBerechnen( 6); break;       
      case 7:pixelBerechnen( 7); break;            
      case 8:pixelBerechnen( 8); break;       
      case 9:pixelBerechnen( 9); break;          
      case 10:pixelBerechnen(10); break;            
      case 11:pixelBerechnen(11); break;       
    }
    println("Threads mit Nummer "+nummer+" ist fertig!");   
    this.running = false;
  }
  
 void pixelBerechnen(int n){//if und else if nur einmal => Beschleunigung
     startPunkteBerechnen(n,abstandScreen);
     gedrehtePunkteBerechnen(n,alY,alX);   
     if(normal){//keine Leuchtkraft, kein Kontrast
       for(int j = 0; j<aufloesung*aufloesung/aT;j++){
           raumBildPunkt[n] = raumBildPunkte[n].get(j); 
           raumRichtungEV[n] = raumRichtungEVs[n].get(j); 
                    
          for(int k = kStart; k>-1 ; k--){
           diEst[n] = estimateDistance(n,raumBildPunkt[n][0],raumBildPunkt[n][1],raumBildPunkt[n][2]); 
           if(diEst[n] < 0.0001){      
               pixValuesGray[n][j] += k;      
               if(farbigZeichnen){
                  abstand[n] = sqrt(sq(raumBildPunkt[n][0])+sq(raumBildPunkt[n][1])+sq(raumBildPunkt[n][1]));
                  pixValuesColor[n][j] = (farbFaktor*fVariante*abstand[n])%256;
               }                          
               break;
           }else{
               k--;
               raumBildPunkt[n][0] = raumBildPunkt[n][0] +diEst[n]*raumRichtungEV[n][0];
               raumBildPunkt[n][1] = raumBildPunkt[n][1] +diEst[n]*raumRichtungEV[n][1];
               raumBildPunkt[n][2] = raumBildPunkt[n][2] +diEst[n]*raumRichtungEV[n][2];
            } //end of for else k       
         }//end of for k
         if(n==11){//Info über Rechenfortschritt
           anteilErledigt11=j;
           println(anteilErledigt11/(aufloesung)+"%");
         }       
    }//end of for j
  }else if(leuchtkraft){
     for(int j = 0; j<aufloesung*aufloesung/aT;j++){
           raumBildPunkt[n] = raumBildPunkte[n].get(j); 
           raumRichtungEV[n] = raumRichtungEVs[n].get(j); 
                    
          for(int k = 255; k>-1 ; k--){//if(n==0) print(raumBildPunkt[0],raumBildPunkt[1],raumBildPunkt[2]+"     "); 
           diEst[n] = estimateDistance(n,raumBildPunkt[n][0],raumBildPunkt[n][1],raumBildPunkt[n][2]); 
           if(diEst[n] < 0.0001){      
               pixValuesGray[n][j] = 290-1.2*k;//a*k*k-2*k+330;               
               if(farbigZeichnen){
                  abstand[n] = sqrt(sq(raumBildPunkt[n][0])+sq(raumBildPunkt[n][1])+sq(raumBildPunkt[n][1]));
                  pixValuesColor[n][j] = (farbFaktor*fVariante*abstand[n])%256;
               }                          
               break;
           }else{
               k--;
               raumBildPunkt[n][0] = raumBildPunkt[n][0] +diEst[n]*raumRichtungEV[n][0];
               raumBildPunkt[n][1] = raumBildPunkt[n][1] +diEst[n]*raumRichtungEV[n][1];
               raumBildPunkt[n][2] = raumBildPunkt[n][2] +diEst[n]*raumRichtungEV[n][2];
            } //end of for else k       
         }//end of for k
         if(n==11){//Info über Rechenfortschritt
           anteilErledigt11=j;
          // println(anteilErledigt11/(aufloesung)+"%");
         }       
    }//end of for j
   }else if(kontrast){
      for(int j = 0; j<aufloesung*aufloesung/aT;j++){
           raumBildPunkt[n] = raumBildPunkte[n].get(j); 
           raumRichtungEV[n] = raumRichtungEVs[n].get(j); 
                    
          for(int k = 255; k>-1 ; k--){//if(n==0) print(raumBildPunkt[0],raumBildPunkt[1],raumBildPunkt[2]+"     "); 
           diEst[n] = estimateDistance(n,raumBildPunkt[n][0],raumBildPunkt[n][1],raumBildPunkt[n][2]); 
           if(diEst[n] < 0.0001){      
               pixValuesGray[n][j] = 2*b*k*k*k;                
               if(farbigZeichnen){
                  abstand[n] = sqrt(sq(raumBildPunkt[n][0])+sq(raumBildPunkt[n][1])+sq(raumBildPunkt[n][1]));
                  pixValuesColor[n][j] = (farbFaktor*fVariante*abstand[n])%256;
               }                          
               break;
           }else{
               k--;
               raumBildPunkt[n][0] = raumBildPunkt[n][0] +diEst[n]*raumRichtungEV[n][0];
               raumBildPunkt[n][1] = raumBildPunkt[n][1] +diEst[n]*raumRichtungEV[n][1];
               raumBildPunkt[n][2] = raumBildPunkt[n][2] +diEst[n]*raumRichtungEV[n][2];
            } //end of for else k       
         }//end of for k
         if(n==11){//Info über Rechenfortschritt
           anteilErledigt11=j;
          // println(anteilErledigt11/(aufloesung)+"%");
         }       
    }//end of for j
   }
 }//end of pixelBerechnen 
 
//----------------------------------------------------------------------
 float estimateDistance(int n, float X, float Y, float Z){
      int   N  = 0;
      float dr = 1;
      float nx = X;
      float ny = Y;
      float nz = Z;
      float[] dE= new float[12];
      float rad = sqrt(X*X+Y*Y+Z*Z);
      while (N < maxIt) {
              float powRad = pow(rad, exp);
              float theta = atan2(sqrt(nx*nx+ny*ny), nz)*exp;
              float phi = atan2(ny, nx)*exp;
              switch(wahlVariante){//Wahl der Version
                case 1:
                  nx = sin(theta)*cos(phi)*powRad+nx;
                  ny = sin(theta)*sin(phi)*powRad+ny;
                  nz = cos(theta)*powRad+nz;  
                  break;
                case 2:
                  nx = sin(theta)*cos(phi)*cos(phi)*powRad+nx;
                  ny = sin(theta)*sin(theta)*sin(phi)*powRad+ny;
                  nz = cos(theta)*powRad+nz;
                  break;
                case 3:
                  nx = sin(theta)*cos(phi)*sqrt(powRad)+nx;
                  ny = sin(theta)*sin(phi)*sqrt(powRad)+ny;
                  nz = cos(theta)*powRad+nz;
                  break;
                case 4:
                  nx = cos(theta)*cos(phi)*powRad+nx;
                  ny = sin(theta)*sin(phi)*powRad+ny;
                  nz = sin(theta)*powRad+nz;       
                  break;
                case 5:
                  nx = sin(theta)*sin(theta)*cos(phi)*powRad+nx;
                  ny = sin(theta)*sin(phi)*sin(phi)*powRad+ny;
                  nz = cos(theta)*powRad+nz;
                  break;
                case 6:
                  nx = sin(theta)*cos(1/(phi+PI))*powRad+nx;
                  ny = sin(theta)*sin(1/(phi+PI))*powRad+ny;
                  nz = cos(theta)*powRad+nz;  
                  break;
                case 7:
                  nx = sin(theta+phi)*cos(phi)*powRad+nx;
                  ny = sin(theta+phi)*sin(phi)*powRad+ny;
                  nz = cos(theta+phi)*powRad+nz;  
                  break;
                case 8:
                  nx = sin(theta)/(2+cos(theta))*cos(phi)*powRad+nx;
                  ny = sin(theta)/(2+cos(theta))*sin(phi)*powRad+ny;
                  nz = cos(theta)/(2+sin(theta))*powRad+nz;  
                  break;
                case 9:
                  nx = sin(theta)*cos(phi)/(2+sin(phi))*powRad+nx;
                  ny = sin(theta)*sin(phi)/(2+cos(phi))*powRad+ny;
                  nz = cos(theta)*powRad+nz;  
                  break;  
                case 10:
                  nx = sin(theta)/(2+cos(theta))*cos(phi)/(2+sin(phi))*powRad+nx;
                  ny = sin(theta)/(2+cos(theta))*sin(phi)/(2+cos(phi))*powRad+ny;
                  nz = cos(theta)/(2+cos(theta))*powRad+nz;  
                  break;  
              }
              dr = dr*exp*pow(rad, exp-1)+1;
              rad = sqrt(nx*nx+ny*ny+nz*nz);
              if (rad > 2) break;
              N++;
     }//end of while
     dE[n] = 0.28*log(rad)*rad/dr;//eigentlich 0.5*... 0.28* wegen overstepping
     return dE[n]; 
 } //end of estimateDistance
//-------------------------------------------------------------------  
}//end of WorkThread
